import org.omg.PortableServer.*;
import Backup.*;
public class DummyStorageImpl extends StoragePOA {
  Agent ag;
  POA poa;
  
  public DummyStorageImpl (POA poa, Agent ag) {
    this.poa = poa;
    this.ag = ag;
    try {
      poa.activate_object(this);
    } catch (Exception e) {
      Global.LogMessage("DStorageImpl(POA,Agent)", e.getMessage());
    }
  }

  public DummyStorageImpl (POA poa) throws Exception {
    this.poa = poa;
    AgentImpl ag1;
    ag1=new AgentImpl("Storage", "");
    poa.activate_object(ag1);
    ag = AgentHelper.narrow(poa.servant_to_reference(ag1));
  }

  public void expireFiles(String agent, String before) {
    Global.LogMessage("DummyStorage.expireFiles()", "older than " + before);
  }

  public void setRestoreInterval(String sid, String from, String to) {
    Global.LogMessage("DummyStorage.setRestoreInterval()", "sid: " + sid+
                                                          " from:" + from+
							  " to:" + to
    );							  
  }
  
  public void endSession(String sid) throws IDException {
    ag.endSession(sid);
  }
  
  public FileIterator sendFiles(String sid, String[] fm) 
                                               throws IDException {
    try {
      ag.startSession("",sid);
    } catch (Exception e) {}
    return ag.sendFiles(sid, fm);
  }
  
  public FileChunker getFile(String fn) throws FileException {
    return ag.getFile(fn);
  }
  
  public void backupFiles(Agent src, String sid, String[] fm) {
    try {
      ag.startSession("",sid);
      ag.restoreFiles(StorageHelper.narrow(
                       poa.servant_to_reference(
                        new DummyStorageImpl(poa, src)))
                                             , sid, fm, false);
      ag.endSession(sid);
      src.endSession(sid);
    } catch (Exception e) {
      System.err.println(e);
    }
  }
}
