import Backup.*;
import java.util.Vector;
import java.util.Iterator;
import java.io.IOException;

public class FileIteratorImpl extends FileIteratorPOA {
   protected int position = 0;
   protected FileSender caller=null; // for getFile
   protected Vector filelist;
   protected FileChunker last=null;
   
   public FileIteratorImpl(Vector filelist) {
      this.filelist=(Vector)filelist.clone();
   }
   
   public FileIteratorImpl(Vector filelist, FileSender caller) {
      this(filelist); 
      this.caller=caller;
   }

   public synchronized boolean hasMoreFiles() {
     if (position < filelist.size()) {
       return true;
     } else {
       if ( last != null) {
         last._release();
       }
       return false;
     }
   }
   
   protected FileChunker getFile(int position) throws FileException {
     // Volani toString zaruci retezec, i kdyz uz jej stejne mame
     if (caller == null) {
       try {
         FileChunkerImpl fci;
         fci=new FileChunkerImpl(filelist.elementAt(position).toString());
         return FileChunkerHelper.narrow(
                   _default_POA().servant_to_reference(fci)
                );
       } catch (Exception e) {
         System.err.println(e);
           Global.LogMessage("Filechunker.getFile()" ,"FileIterator for " +
                                       filelist.elementAt(position).toString() +
                                       " failed: " + e
           );
	 
         throw new FileException();
       }
     } else {
       return caller.getFile(filelist.elementAt(position).toString());
     }
   }

   public synchronized FileChunker nextFile() 
                                  throws BeyondLastException, FileException {
     if ( last != null) {
       last._release();
     }
     if (! hasMoreFiles()) {
       Global.LogMessage("Filechunker.nextFile()",
                         "Trying to call nextFile() after the last one"
                 );
       throw new BeyondLastException();
     }
     position++;
     return last=getFile(position-1);
   }

   public synchronized FileChunker retryFile() 
                                 throws BeforeFirstException, FileException  {
     if ( last != null) {
       last._release();
     }
     if (position < 1) {
       Global.LogMessage("Filechunker.nextFile()",
                         "Trying to call retryFile() before first nextFile()"
                 );
       throw new BeforeFirstException();
     }
     return last=getFile(position-1);
   } 
}
