import Backup.*;
import java.io.*;
import java.util.Date;

public class LoggerImpl extends LoggerPOA {

  protected DataOutputStream out;
  protected boolean nostderr = true;
  
  public LoggerImpl() {
    super();
    this.out = new DataOutputStream(System.err);
    nostderr = false;
  }

  public LoggerImpl(String fileName) throws IOException {
    this(new FileOutputStream(fileName,true)); // Append
  }
  
  public LoggerImpl(OutputStream os) throws IOException {
    super();
    if (os == System.err) {
      nostderr = false;
    }
    this.out=new DataOutputStream(os);
  }
  
 
  public void logMessage(String invoker, String message) {
      String invname;
      
      if (out == null) { // Zahazujeme logy, jen po chybe
        return;
      }
       
      try {
        out.writeChars("[" + new Date() + "] " + invoker 
                           + ": " + message + '\n'       );
        out.flush();
      } 
      catch (IOException e) {
        if (this.nostderr) {
          nostderr = false;
          this.out = new DataOutputStream(System.err);
          logMessage("Logger", "Can't write to log: " + e);
          logMessage(invoker, message);
        } else {
         this.out=null; // Opravdu kriticka situlace
        }
      }
  }
}
