import java.awt.*;
import javax.swing.*;
import java.awt.event.*;
import java.util.Vector;
import java.util.Date;
import java.util.Locale;
import Backup.*;
import Backup.RepeatFreqPackage.*;
import java.text.*;


public class RestoreFrame extends JFrame {
  public static String DATE_FORMAT = "yyyyMMdd";
  public static String TIME_FORMAT = "HHmm";

  String[] filemasks = new String[0];
  public static String INIT_STRING="000001010000";
  String fromDate = INIT_STRING;
  String toDate =null;
  JPanel contentPane;
  GUI gui=null;
  RulesListPanel rlPanel=null;
  Locale locale=Locale.GERMANY;

  JCheckBox replaceCBox = new JCheckBox();
  JLabel fileMLabel = new JLabel();
  JTextField fileMField = new JTextField();
  JButton replaceMaskButton = new JButton();
  JButton addButton = new JButton();
  JTextField dateField = new JTextField();
  JTextField timeField = new JTextField();
  JLabel dateLabel = new JLabel();
  JLabel timeLabel = new JLabel();
  List masksList = new List();
  JButton delMaskButton = new JButton();
  JButton okButton = new JButton();
  JButton stornoButton = new JButton();
  JLabel timeLabel1 = new JLabel();
  JLabel dateLabel1 = new JLabel();
  JTextField timeField1 = new JTextField();
  JTextField dateField1 = new JTextField();
  JLabel dateLabel2 = new JLabel();
  JLabel errorLabel = new JLabel();

  public RestoreFrame() {
    try {
      jbInit();
    }
    catch(Exception e) {
      e.printStackTrace();
    }
  }

  public String getToDate(){
    return toDate;
  }

  public String getFromDate(){
    return fromDate;
  }
  
  public RestoreFrame(GUI gui, RulesListPanel rlPanel) {
    this.gui=gui;
    this.rlPanel=rlPanel;

    try {
      jbInit();
    }
    catch(Exception e) {
      e.printStackTrace();
    }
  }

  public RestoreFrame(GUI gui,RulesListPanel rlPanel, Locale locale) {
    this.gui=gui;
    this.rlPanel=rlPanel;
    this.locale=locale;
    try {
      jbInit();
    }
    catch(Exception e) {
      e.printStackTrace();
    }
  }


  private void setDates() {
    Date date;
    Date date2;
    if (fromDate == null || fromDate.compareTo("")==0) {
      try{
        date=DateUtil.toDate(INIT_STRING);
      } catch(java.text.ParseException e) {
        System.err.println("Bad DateTime"+e);
        date=new Date();
      }
    }
    else {
      try{
        date=DateUtil.toDate(fromDate);
      } catch(java.text.ParseException e) {
        System.err.println("Bad DateTime"+e);
        date=new Date();
      }
    }
    if (toDate == null || toDate.compareTo("")==0){
      date2 = new Date();
     } else {
      try{
        date2=DateUtil.toDate(toDate);
      } catch(java.text.ParseException e) {
        System.err.println("Bad DateTime"+e);
        date2=new Date();
      }
    }
    dateField1.setText(DateFormat.getDateInstance(
        DateFormat.MEDIUM,locale).format(date));
    timeField1.setText(DateFormat.getTimeInstance(
        DateFormat.SHORT,locale).format(date));
    dateField.setText(DateFormat.getDateInstance(
        DateFormat.MEDIUM,locale).format(date2));
    timeField.setText(DateFormat.getTimeInstance(
        DateFormat.SHORT,locale).format(date2));

  }


  private String parseDate(String date, String time) 
		throws java.text.ParseException{
      String s;
      Date d;
 
      SimpleDateFormat dateFormat = new SimpleDateFormat(DATE_FORMAT);
      SimpleDateFormat timeFormat = new SimpleDateFormat(TIME_FORMAT);
      if(date==""){
        d = new Date();
        s=dateFormat.format(d);
      }
      DateFormat df = DateFormat.getDateInstance(DateFormat.MEDIUM,locale);
      df.setLenient(false);
      d=df.parse(date);
      Date max=DateFormat.getDateInstance(DateFormat.MEDIUM,locale)
        .parse("31.12.9999");
      if(d.compareTo(max)>0){
        throw new java.text.ParseException("Date is to high",0);
      }
      s=dateFormat.format(d);
      if(time==""){
        d = new Date();
        s=dateFormat.format(d);
      }
      d=DateFormat.getTimeInstance(DateFormat.SHORT,locale)
          .parse(time);
      s=s.concat(timeFormat.format(d));

      return s;
  }


  private void setListValue(String[] fmseq) {
    masksList.removeAll();
    for( int i=0; i<fmseq.length;i++){
      masksList.add(fmseq[i]);
    }
    if(fmseq.length>0){
      masksList.select(0);
    }
    if(masksList.getItemCount()==0){
      replaceMaskButton.setEnabled(false);
      delMaskButton.setEnabled(false);
    }    
  }

  //Overridden so we can exit when window is closed
  protected void processWindowEvent(WindowEvent e) {
    super.processWindowEvent(e);
    if (e.getID() == WindowEvent.WINDOW_CLOSING) {
      rlPanel.controlBack();
    }
  }

  public void reset(){
    replaceCBox.setSelected(false);
    filemasks = new String[0];
    masksList.removeAll();
    replaceMaskButton.setEnabled(false);
    delMaskButton.setEnabled(false);
    fileMField.setText("");
    fromDate = null;
    toDate = null;
    errorLabel.setText("");
    setDates();
  }

  private void jbInit() throws Exception {
    contentPane = (JPanel) this.getContentPane();
    contentPane.setLayout(null);
    this.setSize(new Dimension(455, 380));
    this.setTitle("Restore");

    replaceCBox.setSelected(false);
    replaceCBox.setText("Replace");
    replaceCBox.setBounds(new Rectangle(300, 10, 100, 25));


    dateField.setBounds(new Rectangle(130, 70, 95, 25));
    dateField.addFocusListener(new java.awt.event.FocusAdapter() {
      public void focusLost(FocusEvent e) {
	testDates();
      }
    });

    timeField.setBounds(new Rectangle(290, 70, 70, 25));
    timeField.addFocusListener(new java.awt.event.FocusAdapter() {
      public void focusLost(FocusEvent e) {
        testDates();
      }
    });


    dateLabel.setText("Date:");
    dateLabel.setBounds(new Rectangle(80, 70, 40, 25));
    timeLabel.setText("Time:");
    timeLabel.setBounds(new Rectangle(240, 70, 45, 25));
    timeLabel.setHorizontalAlignment(SwingConstants.RIGHT);
    fileMLabel.setText("File mask:");
    fileMLabel.setBounds(new Rectangle(10, 110, 80, 25));
    fileMField.setBounds(new Rectangle(100, 110, 270, 25));
    fileMField.addFocusListener(new java.awt.event.FocusAdapter() {

      public void focusGained(FocusEvent e) {
        fileMFieldFocusGained(e);
      }
    });
    masksList.setBounds(new Rectangle(10, 145, 270, 120));
    masksList.addItemListener(new java.awt.event.ItemListener() {

      public void itemStateChanged(ItemEvent e) {
        masksListStateChanged(e);
      }
    });
    masksList.setMultipleMode(false);
    delMaskButton.setText("Delete mask");
    delMaskButton.setBounds(new Rectangle(290, 145, 145, 25));
    delMaskButton.addActionListener(new java.awt.event.ActionListener() {

      public void actionPerformed(ActionEvent e) {
        delMaskButtonAction(e);
      }
    });
    replaceMaskButton.setText("Replace mask");
    replaceMaskButton.setBounds(new Rectangle(290, 175, 145, 25));
    replaceMaskButton.addActionListener(new java.awt.event.ActionListener() {

      public void actionPerformed(ActionEvent e) {
        replaceMaskButtonAction(e);
      }
    });
    addButton.setText("Add mask");
    addButton.setBounds(new Rectangle(290, 205, 145, 25));
    addButton.addActionListener(new java.awt.event.ActionListener() {

      public void actionPerformed(ActionEvent e) {
        addButtonAction(e);
      }
    });
    okButton.setText("Restore");
    okButton.setBounds(new Rectangle(60, 285, 145, 25));
    okButton.addActionListener(new java.awt.event.ActionListener() {

      public void actionPerformed(ActionEvent e) {
        okButtonAction(e);
      }
    });
    stornoButton.setText("Storno");
    stornoButton.setBounds(new Rectangle(240, 285, 145, 25));
    stornoButton.addActionListener(new java.awt.event.ActionListener() {

      public void actionPerformed(ActionEvent e) {
        stornoButtonAction(e);
      }
    });
    setDates();
    this.replaceMaskButton.setEnabled(false);
    this.delMaskButton.setEnabled(false);

    timeLabel1.setHorizontalAlignment(SwingConstants.RIGHT);
    timeLabel1.setBounds(new Rectangle(240, 40, 45, 25));
    timeLabel1.setText("Time:");
    dateLabel1.setBounds(new Rectangle(80, 40, 40, 25));
    dateLabel1.setText("Date:");
    timeField1.setBounds(new Rectangle(290, 40, 70, 25));
    timeField1.addFocusListener(new java.awt.event.FocusAdapter() {
      public void focusLost(FocusEvent e) {
        testDates();
      }
    });
    this.addFocusListener(new java.awt.event.FocusAdapter() {
      public void focusGained(FocusEvent e) {
        fileMField.requestFocus();
      }
    });

    dateField1.setBounds(new Rectangle(130, 40, 95, 25));
    dateField1.addFocusListener(new java.awt.event.FocusAdapter() {
      public void focusLost(FocusEvent e) {
        testDates();
      }
    });

    dateLabel2.setText("Stored between");
    dateLabel2.setBounds(new Rectangle(10, 10, 150, 25));
    errorLabel.setForeground(Color.red);
    errorLabel.setText("");
    errorLabel.setBounds(new Rectangle(10, 320, 400, 25));
    contentPane.add(fileMField, null);
    contentPane.add(fileMLabel, null);
    contentPane.add(masksList, null);
    contentPane.add(replaceMaskButton, null);
    contentPane.add(delMaskButton, null);
    contentPane.add(addButton, null);
    contentPane.add(okButton, null);
    contentPane.add(stornoButton, null);
    contentPane.add(dateLabel2, null);
    contentPane.add(dateField1, null);
    contentPane.add(dateLabel1, null);
    contentPane.add(timeLabel1, null);
    contentPane.add(timeField1, null);
    contentPane.add(dateLabel, null);
    contentPane.add(dateField, null);
    contentPane.add(timeLabel, null);
    contentPane.add(timeField, null);
    contentPane.add(errorLabel, null);
    contentPane.add(replaceCBox, null);
    setResizable(false);
	
  }


  void addButtonAction(ActionEvent e) {
    if(fileMField.getText().compareTo("") != 0 && fileMField.getText()!=null){
      this.replaceMaskButton.setEnabled(true);
      this.delMaskButton.setEnabled(true);
      String[] newList = new String[filemasks.length+1];
      for(int i=0;i<filemasks.length;i++) {
        newList[i]=filemasks[i];
      }
      newList[filemasks.length]=fileMField.getText();
      filemasks=newList;
      masksList.add(fileMField.getText());
      masksList.select(filemasks.length-1);
    }
    if(masksList.getItemCount()!=0){
      replaceMaskButton.setEnabled(true);
      delMaskButton.setEnabled(true);
    }    
  }

  void masksListStateChanged(ItemEvent e) {
    fileMField.setText(filemasks[masksList.getSelectedIndex()]);
    fileMField.setEditable(true);
  }

  void replaceMaskButtonAction(ActionEvent e) {
    int selected = masksList.getSelectedIndex();
    if(fileMField.getText()!=""){
      filemasks[selected]=fileMField.getText();
      masksList.replaceItem(fileMField.getText(),selected);
      masksList.select(selected);
    }
  }

  void delMaskButtonAction(ActionEvent e) {
    int selected = masksList.getSelectedIndex();
    if(fileMField.getText()!=""){
      String[] newList = new String[filemasks.length-1];
      for(int i=0;i<filemasks.length;i++) {
        int j=0;
        if(i!= selected){
          newList[j]=filemasks[i];
          j++;
        }
      }
      filemasks=newList;
      masksList.remove(selected);
      masksList.select(0);
    }
    if(this.masksList.getItemCount()==0) {
      this.replaceMaskButton.setEnabled(false);
      this.delMaskButton.setEnabled(false);
    }
  }
  
  private boolean testDates() {
    try {
      fromDate = this.parseDate(dateField1.getText(),timeField1.getText());
      try {
        toDate = this.parseDate(dateField.getText(),timeField.getText());
        if (toDate.compareTo(fromDate)<0){
          String a=toDate;
          toDate=fromDate;
          fromDate=a;
        }
        errorLabel.setText("");
        setDates();
        return true;
      } catch (java.text.ParseException e){
        errorLabel.setText("Bad date or time");
        return false;
      }

    } catch (java.text.ParseException e){
      errorLabel.setText("Bad date or time");
      return false;
    }
  }
  
 
  void okButtonAction(ActionEvent e) {
    if (testDates() == true) {
      this.hide();
      MessageFrame messageFrame= new MessageFrame("Restoring...");
      if(filemasks.length != 0) { 
        messageFrame.show();
        gui.restoreFiles(this,filemasks,replaceCBox.isSelected());
        messageFrame.dispose();
      }
      rlPanel.controlBack();
    }
  }

  void stornoButtonAction(ActionEvent e) {
    rlPanel.controlBack();
  }

  void fileMFieldFocusGained(FocusEvent e) {
    fileMField.setSelectionStart(0);
    fileMField.setSelectionEnd(fileMField.getText().length());
  }

}
