import java.io.*;
import java.util.*;
import java.lang.*;
import java.util.zip.*;

public class StorageFileMaskExpander{

  protected Vector v;
  protected String mask;
  protected HashSet table;

public StorageFileMaskExpander() {
  table = new HashSet();
}


Vector  getChildren(String name, Vector names) {
  Vector output = new Vector();

  for (int i=0; i < names.size(); i++) {
   String temp  = (String) names.get(i);
   
    if (temp.startsWith(name)) {
      if (temp.length() == name.length()) {
          output.add(temp);
      } else {
          int index = name.length();
          if (temp.charAt(index) == File.separatorChar)
              output.add(temp);
      }        
    }
  }
  return output;      
}


private Vector cutNames(String adresar, Vector names) {

  Vector output = new Vector();

  for (int i=0; i < names.size(); i++) {
   String temp  = (String) names.get(i);
    if (temp.startsWith(adresar)) {
       
      int index = adresar.length();
      
      int index2 = temp.indexOf(File.separatorChar, index);
     if (index2 != -1) { 
      output.add(temp.substring(0, index2));
     } else
     {
       output.add(temp);
       } 
    }  
  }
  
  return output;        

}


private Vector expandOneMask2(String mask, Vector names) { 
  int ind = mask.lastIndexOf('*');
  if(ind == -1) {		
    return getChildren(mask, names);
  }
  else {
  
    Vector output = new Vector();
    String adresar = mask;
    parseMask(mask);    
    
    ind = adresar.lastIndexOf(File.separatorChar);
    
    if(ind != -1) {
      Vector all=new Vector();
      adresar = adresar.substring(0,ind+1);
      Vector select = cutNames(adresar, names);
      
      if(select.size() == 0) {
        return output;
      }
    
    
      for(int i=0;i<select.size();i++){
	if(correspond((String) select.get(i))){
          all.addElement(getChildren((String) select.get(i), names));
        }
      }
      
      for (int i= 0; i < all.size(); i++ ) {
        Vector temp = (Vector) all.get(i);
        for (int j = 0;  j < temp.size(); j++) {
	  output.add(temp.get(j));
	}
      }	            
    }
    return output;
  }
}


private void parseMask(String mask){
  v = new Vector();
  int ind;
  int oldind;
  String s;
  ind = mask.indexOf('*');
  this.mask = mask;
  if (ind != -1) {
    if(ind > 0) {
      s = mask.substring(0,ind);
      v.addElement(s);
    }
    while(ind != -1){
      if(ind != mask.length()-1){
        oldind = ind;
        ind = mask.indexOf('*',ind+1);
        if (ind != -1) {
          v.addElement(mask.substring(oldind+1,ind));
        } else {
          v.addElement(mask.substring(oldind+1,mask.length()));
        }
      }
      else {
        break;
      }
    }
  }
  else {
    v.addElement(mask);
  }
}


private boolean correspond(String name){
  int pos = 0;
  for(int i=0;i<v.size();i++){
    pos = name.indexOf((String)v.elementAt(i),pos);
    if(pos == -1){
      return false;
    }
    pos+=((String)v.elementAt(i)).length();
  }
  if(mask.charAt(0)!='*') {
    if(!name.startsWith((String)v.elementAt(0))) {
      return false;
    }
  }
  if(mask.charAt(mask.length()-1)!='*') {
    if(!name.endsWith((String)v.elementAt(v.size()-1))) {
      return false;
    }
  }
  return true;
}

private Vector getInnerNames(ZipFile zipFile) {
   
  Vector names = new Vector();

  for (Enumeration e = zipFile.entries(); e.hasMoreElements(); ) {
     ZipEntry entry = (ZipEntry) e.nextElement();
     names.add(entry.getName());
  }

  return names;
}

 
 public Vector expandMask(String[] masks, Vector zipFiles) {
    Vector unmasked = new Vector();
    
   /* for (int i= 0; i < masks.length ; i++)
      System.out.println(masks[i]);		*/
    
    ZipFile zFile;

    for(int k=0; k < zipFiles.size(); k++) {
      zFile = (ZipFile) zipFiles.get(k); 
      Vector names = getInnerNames(zFile);
    
    for (int i=0; i < masks.length; i++) {
      Vector um=expandOneMask2(masks[i], names);
      for (int j=0; j < um.size(); j++) {
         // unmasked.addElement(um[j]);
	 if (table.add((String) um.get(j))) {
	     table.add(k+"*"+(String) um.get(j));
	     unmasked.add(k + "*" + (String) um.get(j));
	     //System.out.println(k + "*" + (String) um.get(j));
	}     
      }
    }
    }
    
     
    return unmasked;
  }


}
