import Backup.*;
// Server.java
import org.omg.CosNaming.NameComponent;
import org.omg.CosNaming.NamingContextPackage.*;
import org.omg.PortableServer.*;
import java.io.*;

public class StorageServer {
  public static String name = "Storage";

  public static void main(String[] args) {
    try {
      // Initialize the ORB.
      org.omg.CORBA.ORB orb = org.omg.CORBA.ORB.init(args,null);

      // get a reference to the root POA
      POA rootPOA = POAHelper.narrow(orb.resolve_initial_references("RootPOA"));

      // Create policies for our persistent POA
      org.omg.CORBA.Policy[] policies = {
        rootPOA.create_lifespan_policy(LifespanPolicyValue.TRANSIENT)
      };
      // Create myPOA with the right policies
      POA myPOA = rootPOA.create_POA( "myStoragePOA", rootPOA.the_POAManager(),
                                        policies );

      // Create the servant
      StorageImpl _Storage = new StorageImpl(/*Constructor args*/);

      // Activate the servant with the ID on myPOA
      myPOA.activate_object(_Storage);

      // Activate the POA manager
      rootPOA.the_POAManager().activate();


       org.omg.CORBA.Object ref=myPOA.servant_to_reference(_Storage);
        
      if (!Global.Initialize(orb)) {
         System.out.println("\nInit of NameService failed - "
                         +"it may not be running where you specified,\n"
                         +"or you didn't give the argument -ORBservice "
                         +"NameService <loc>,\nwhere <loc> is either IOR or "
                         +"corbaloc::host:port/NameService"                   );
         System.exit(1);
      }
      
      
      try {
        if ( ! Global.bind(name, ref) ) {
          System.err.println(name + ": Can't bind to NamingService");
        }
      } catch (AlreadyBound e) {
         org.omg.CORBA.Object oldref=Global.Get(name);
        try {
          boolean result = oldref._non_existent();
          if (result) {
            throw new Exception();
          } else {
             System.err.println("Can't start: Different instance "
                                + "of " + name + " is running"           );
             System.exit(1);
          }
        } catch (Exception g) {
          try {
            NameComponent [] nc ={new NameComponent(name," ")};
            Global.GetNaming().unbind(nc);
            Global.bind(name, ref);
          } catch (Exception f) {
            System.out.println(name +": Can't bind to NamingService: " +f);
            System.exit(1);
          }
        }
      }
      
      Global.LogMessage("StorageServer.main() ", "Storage server " + name + " started");
      
      // Wait for incoming requests
      orb.run();
    }
    catch (Exception e) {
      e.printStackTrace();
    }
  }

}
